# Changelog

## [3.0.2](https://github.com/primefaces/primevue/tree/3.0.2) (2020-11-26)

[Full Changelog](https://github.com/primefaces/primevue/compare/3.0.1...3.0.2)

**Implemented New Features and Enhancements:**

- Add the 'enter' key support to InputNumber [\#675](https://github.com/primefaces/primevue/issues/675)
- Chips mode for MultiSelect [\#673](https://github.com/primefaces/primevue/issues/673)
- New Timeline Component [\#672](https://github.com/primefaces/primevue/issues/672)
- Toolbar requires slot attribute which is deprecated in Vue.js 3 [\#639](https://github.com/primefaces/primevue/issues/639)
- SelectButton should allow a mode to ensure an options is always selected [\#494](https://github.com/primefaces/primevue/issues/494)

**Fixed bugs:**

- SplitButton: after selecting the default command, the command menu does not close. [\#660](https://github.com/primefaces/primevue/issues/660)
- Multiselect/Dropdown: when the menu open upwards style broken [\#659](https://github.com/primefaces/primevue/issues/659)
- Autocomplete: when the menu open upwards style broken [\#658](https://github.com/primefaces/primevue/issues/658)
- DataTable global filter bug [\#655](https://github.com/primefaces/primevue/issues/655)
- Closing message and reopening it does not work [\#653](https://github.com/primefaces/primevue/issues/653)
- Password element does not inherit attributes [\#651](https://github.com/primefaces/primevue/issues/651)
- DataTable sortField allows a function, but the prop type is only a string [\#647](https://github.com/primefaces/primevue/issues/647)
- Missing .d.ts file for usetoast [\#645](https://github.com/primefaces/primevue/issues/645)
- InputNumber's onInputBlur fails when component gets destroyed [\#633](https://github.com/primefaces/primevue/issues/633)
- missing type definition for toast/useToast.js [\#630](https://github.com/primefaces/primevue/issues/630)
- Sidebar not visible on mount [\#627](https://github.com/primefaces/primevue/issues/627)
- Accordion does not support dynamic tabs [\#622](https://github.com/primefaces/primevue/issues/622)
- TabView does not support dynamic tabs [\#616](https://github.com/primefaces/primevue/issues/616)
- PrimeVue FileUpload FileLimit [\#610](https://github.com/primefaces/primevue/issues/610)
- DataTable multiple click RadioButton focus previous row [\#606](https://github.com/primefaces/primevue/issues/606)
- FileUpload Preview columns become misaligned when both image and non-image files are uploaded [\#585](https://github.com/primefaces/primevue/issues/585)
- Error with empty objects [\#556](https://github.com/primefaces/primevue/issues/556)
- OverlayPanel :before "indicator" needs dynamic placement [\#490](https://github.com/primefaces/primevue/issues/490)

## [3.0.1](https://github.com/primefaces/primevue/tree/3.0.1) (2020-10-22)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.2.0...3.0.1)

**Implemented New Features and Enhancements:**

- Do not hide overlays on body scroll [\#591](https://github.com/primefaces/primevue/issues/591)
- Add inputStyle and inputClass properties to InputNumber [\#551](https://github.com/primefaces/primevue/issues/551)
- Declare events in "emits" section of every component [\#549](https://github.com/primefaces/primevue/issues/549)

**Fixed bugs:**

- Overriding ProgressSpinner colors doc error [\#589](https://github.com/primefaces/primevue/issues/589)
- Property "disabled" was accessed during render but is not defined on instance. [\#587](https://github.com/primefaces/primevue/issues/587)
- Dropdown inside datable using showClear causing: Cannot read property 'classList' of null [\#586](https://github.com/primefaces/primevue/issues/586)
- DataTable crashes with a "Cannot read property 'xxx' of null" for nested objects [\#555](https://github.com/primefaces/primevue/issues/555)
- pRipple works even when disabled\(etc menuitem\) [\#550](https://github.com/primefaces/primevue/issues/550)
- Website / Documentation - Fix third-party dependencies documentation [\#546](https://github.com/primefaces/primevue/issues/546)
- Menu components with web router refresh the whole page [\#536](https://github.com/primefaces/primevue/issues/536)

## [3.0.0](https://github.com/primefaces/primevue/tree/3.0.0) (2020-10-11)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.1.0...3.0.0)

**Implemented New Features and Enhancements:**

- Galleria and Carousel highlight item visual improvement on PrimeOne Themes [\#545](https://github.com/primefaces/primevue/issues/545)
- Soho Theme [\#539](https://github.com/primefaces/primevue/issues/539)
- Fluent UI Theme [\#538](https://github.com/primefaces/primevue/issues/538)
- ToastService $toast is not accessible using Composition API [\#535](https://github.com/primefaces/primevue/issues/535)
- Tooltip doesn't close in scrollable containers [\#523](https://github.com/primefaces/primevue/issues/523)
- Lighter Highlight Color for PrimeOne Themes [\#520](https://github.com/primefaces/primevue/issues/520)
- Add indentation property to TreeTable [\#495](https://github.com/primefaces/primevue/issues/495)
- Accordion rounded border minor visual issue [\#384](https://github.com/primefaces/primevue/issues/384)

**Fixed bugs:**

- Tree selection is broken when ripple is enabled [\#543](https://github.com/primefaces/primevue/issues/543)
- Tree toggler icon hover color is wrong in bootstrap theme [\#542](https://github.com/primefaces/primevue/issues/542)
- The 'disabled' option has no effect on InputNumber [\#537](https://github.com/primefaces/primevue/issues/537)
- InputNumber cannot set value when format property is false [\#533](https://github.com/primefaces/primevue/issues/533)
- InputNumber with spinner mode throws a JS exception [\#532](https://github.com/primefaces/primevue/issues/532)
- inputNumber with numeric prefix is not working as expected [\#531](https://github.com/primefaces/primevue/issues/531)
- Problems when typing or pasting numbers into InputNumber [\#530](https://github.com/primefaces/primevue/issues/530)
- Can't close MultiSelect or Select when inside Dialog component [\#524](https://github.com/primefaces/primevue/issues/524)
- TouchUI modal gets stuck if input tabs out [\#519](https://github.com/primefaces/primevue/issues/519)
- TriStateCheckbox doesn't show correct icon when value is false when using material themes [\#517](https://github.com/primefaces/primevue/issues/517)

## [3.0.0-rc.2](https://github.com/primefaces/primevue/tree/3.0.0-rc.2) (2020-09-29)

[Full Changelog](https://github.com/primefaces/primevue/compare/3.0.0-rc1...3.0.0-rc.2)

**Fixed bugs:**

- 3.0.0-rc.1 npm package includes a node_modules [\#511](https://github.com/primefaces/primevue/issues/511)
- Dialog component VNode [\#510](https://github.com/primefaces/primevue/issues/510)

## [3.0.0-rc.1](https://github.com/primefaces/primevue/tree/3.0.0-rc.1) (2020-09-28)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.9...3.0.0-rc.1)

**Breaking Changes:**

- Accessing column props in Slots [\#498](https://github.com/primefaces/primevue/issues/498)
- activeIndex for TabView and Accordion [\#497](https://github.com/primefaces/primevue/issues/497)

**Implemented New Features and Enhancements:**

- Vue 3 Compatibility [\#491](https://github.com/primefaces/primevue/issues/491)
- Improvement in behavior of components that have overlay panels in scrollable containers [\#500](https://github.com/primefaces/primevue/issues/500)
- Improve calendar tabbing behavior [\#507](https://github.com/primefaces/primevue/issues/507)
- Add input event to InputNumber [\#506](https://github.com/primefaces/primevue/issues/506)

**Fixed bugs:**

- Scrollable Table alignment improvement [\#482](https://github.com/primefaces/primevue/issues/482)
- Button not registered in FileUpload [\#478](https://github.com/primefaces/primevue/issues/478)
- BlockUI documentation indicates "show" event whereas the actual event is "unblock" [\#485](https://github.com/primefaces/primevue/issues/485)

## [2.2.2](https://github.com/primefaces/primevue/tree/2.2.2) (2020-11-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.2.1...2.2.2)

**Implemented New Features and Enhancements:**

- New Timeline Component [\#712](https://github.com/primefaces/primevue/issues/712)
- Chips mode for MultiSelect [\#711](https://github.com/primefaces/primevue/issues/711)
- SelectButton should allow a mode to ensure an options is always selected [\#698](https://github.com/primefaces/primevue/issues/698)
- OverlayPanel :before "indicator" needs dynamic placement [\#697](https://github.com/primefaces/primevue/issues/697)
- Improve typescript definitions [\#696](https://github.com/primefaces/primevue/issues/696)
- Add the 'enter' key support to InputNumber [\#676](https://github.com/primefaces/primevue/issues/676)

**Fixed bugs:**

- SplitButton: after selecting the default command, the command menu does not close. [\#710](https://github.com/primefaces/primevue/issues/710)
- Autocomplete: when the menu open upwards style broken [\#709](https://github.com/primefaces/primevue/issues/709)
- Multiselect/Dropdown: when the menu open upwards style broken [\#708](https://github.com/primefaces/primevue/issues/708)
- DataTable global filter bug [\#707](https://github.com/primefaces/primevue/issues/707)
- InputNumber's onInputBlur fails when component gets destroyed [\#705](https://github.com/primefaces/primevue/issues/705)
- Sidebar not visible on mount [\#704](https://github.com/primefaces/primevue/issues/704)
- PrimeVue FileUpload FileLimit [\#703](https://github.com/primefaces/primevue/issues/703)
- DataTable multiple click RadioButton focus previous row [\#702](https://github.com/primefaces/primevue/issues/702)
- FileUpload Preview columns become misaligned when both image and non-image files are uploaded  [\#701](https://github.com/primefaces/primevue/issues/701)
- Error with empty objects [\#700](https://github.com/primefaces/primevue/issues/700)
- ColorPicker overlay input does not reflect to hue section changes [\#699](https://github.com/primefaces/primevue/issues/699)
- Multiselect dropdown closes after selecting one option [\#602](https://github.com/primefaces/primevue/issues/602)
- PrimeVue 2 InputMask with unmask problem [\#577](https://github.com/primefaces/primevue/issues/577)

##  [2.2.1](https://github.com/primefaces/primevue/tree/2.2.1) (2020-11-23)

**Implemented New Features and Enhancements:**

- Do not hide overlays on body scroll [\#661](https://github.com/primefaces/primevue/issues/661)

**Fixed bugs:**

- Overriding ProgressSpinner colors doc error [\#662](https://github.com/primefaces/primevue/issues/662)
- Dropdown inside datable using showClear causing: Cannot read property 'classList' of null [\#664](https://github.com/primefaces/primevue/issues/664)
- DataTable crashes with a "Cannot read property 'xxx' of null" for nested objects [\#665](https://github.com/primefaces/primevue/issues/665)

##  [2.2.0](https://github.com/primefaces/primevue/tree/2.2.0) (2020-10-14)

**Implemented New Features and Enhancements:**

- Add inputStyle and inputClass properties to InputNumber [\#573](https://github.com/primefaces/primevue/issues/573)
- Accordion rounded border minor visual issue [\#572](https://github.com/primefaces/primevue/issues/572)
- Add indentation property to TreeTable  [\#571](https://github.com/primefaces/primevue/issues/571)
- Lighter Highlight Color for PrimeOne Themes  [\#568](https://github.com/primefaces/primevue/issues/568)
- Fluent UI Theme [\#561](https://github.com/primefaces/primevue/issues/561)
- Soho Theme  [\#560](https://github.com/primefaces/primevue/issues/560)
- Galleria and Carousel highlight item visual improvement on PrimeOne Themes  [\#557](https://github.com/primefaces/primevue/issues/557)
- Tooltip doesn't close in scrollable containers  [\#526](https://github.com/primefaces/primevue/issues/526)

**Fixed bugs:**

- pRipple working when disabled\(etc menuitem\) [\#574](https://github.com/primefaces/primevue/issues/574)
- TriStateCheckbox doesn't show correct icon when value is false when using material themes [\#570](https://github.com/primefaces/primevue/issues/570)
- TouchUI modal gets stuck if input tabs out [\#569](https://github.com/primefaces/primevue/issues/569)
- Can't close MultiSelect or Select when inside Dialog component [\#567](https://github.com/primefaces/primevue/issues/567)
- Problems when typing or pasting numbers into InputNumber [\#566](https://github.com/primefaces/primevue/issues/566)
- inputNumber with numeric prefix is not working as expected [\#565](https://github.com/primefaces/primevue/issues/565)
- InputNumber with spinner mode throws a JS exception [\#564](https://github.com/primefaces/primevue/issues/564)
- InputNumber cannot set value when format property is false [\#563](https://github.com/primefaces/primevue/issues/563)
- The 'disabled' option has no effect on InputNumber [\#562](https://github.com/primefaces/primevue/issues/562)
- Tree toggler icon hover color is wrong in bootstrap theme [\#559](https://github.com/primefaces/primevue/issues/559)
- Tree selection is broken when ripple is enabled [\#558](https://github.com/primefaces/primevue/issues/558)

## [2.1.0](https://github.com/primefaces/primevue/tree/2.1.0) (2020-09-29)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.9...2.1.0)

**Implemented New Features and Enhancements:**

- Improvement in behavior of components that have overlay panels in scrollable containers [\#514](https://github.com/primefaces/primevue/issues/514)
- Scrollable Table alignment improvement [\#513](https://github.com/primefaces/primevue/issues/513)
- Improve calendar tabbing behavior [\#512](https://github.com/primefaces/primevue/issues/512)

**Fixed bugs:**

- TouchUI modal gets stuck if input tabs out [\#518](https://github.com/primefaces/primevue/issues/518)
- Button not registered in FileUpload [\#516](https://github.com/primefaces/primevue/issues/516)
- BlockUI documentation indicates "show" event whereas the actual event is "unblock" [\#515](https://github.com/primefaces/primevue/issues/515)

## [2.0.9](https://github.com/primefaces/primevue/tree/2.0.9) (2020-09-09)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.8...2.0.9)

**Implemented New Features and Enhancements:**

- InputGroup support for input components with wrappers [\#471](https://github.com/primefaces/primevue/issues/471)
- Update PrimeFlex documentation to 2.0.0 [\#464](https://github.com/primefaces/primevue/issues/464)
- Scrollable Table alignment improvement [\#462](https://github.com/primefaces/primevue/issues/462)
- emptyFilterMessage for Dropdown, MultiSelect and Listbox filter [\#459](https://github.com/primefaces/primevue/issues/459)
- Negative sign with InputNumber [\#458](https://github.com/primefaces/primevue/issues/458)
- InputNumber Currency not working as expected [\#330](https://github.com/primefaces/primevue/issues/330)

**Fixed bugs:**

- Dialog with Long Content does not scroll in IE11 [\#473](https://github.com/primefaces/primevue/issues/473)
- Click on Dropdown's filter text box closes items list [\#465](https://github.com/primefaces/primevue/issues/465)
- Calendar misplaced layout if more than one month is shown [\#461](https://github.com/primefaces/primevue/issues/461)
- inputNumber cannot set value bigger than 99.999 for an ES locale [\#460](https://github.com/primefaces/primevue/issues/460)
- Items in PanelMenu are highlighted wrongly with Material dark themes [\#456](https://github.com/primefaces/primevue/issues/456)
- InputNumber with dynamic fraction digits doesn't work as expected [\#455](https://github.com/primefaces/primevue/issues/455)

## [2.0.8](https://github.com/primefaces/primevue/tree/2.0.8) (2020-08-27)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.7...2.0.8)

**Implemented New Features and Enhancements:**

- Add Del key support to InputNumber [\#452](https://github.com/primefaces/primevue/issues/452)
- Documentation for primeflex setup [\#434](https://github.com/primefaces/primevue/issues/434)
- InputNumber with decimals should support entering comma/decimal point [\#432](https://github.com/primefaces/primevue/issues/432)
- dismissableMask and closeOnEscape for Dialog [\#372](https://github.com/primefaces/primevue/issues/372)

**Fixed bugs:**

- Can't type - as first symbol into an Inputnumber  [\#453](https://github.com/primefaces/primevue/issues/453)
- When autocomplete is bound to an object, float label overlaps in some circumstances [\#450](https://github.com/primefaces/primevue/issues/450)
- TreeTable template always render field value [\#445](https://github.com/primefaces/primevue/issues/445)
- Setting placeholder text for Editor / Quill component doesn't work [\#433](https://github.com/primefaces/primevue/issues/433)
- InputNumber with stacked Buttons is broken [\#431](https://github.com/primefaces/primevue/issues/431)
- Doc error on InputNumber [\#430](https://github.com/primefaces/primevue/issues/430)
- InputNumber throws error if emptied [\#429](https://github.com/primefaces/primevue/issues/429)
- Pill Text not centered [\#428](https://github.com/primefaces/primevue/issues/428)

## [2.0.7](https://github.com/primefaces/primevue/tree/2.0.7) (2020-08-05)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.6...2.0.7)

**Fixed bugs:**

- Global filter is not working with invalid values on TreeTable [\#427](https://github.com/primefaces/primevue/issues/427)
- Global filter throws error in TreeTable[\#425](https://github.com/primefaces/primevue/issues/425)
- Duplicate keys in TreeTable [\#424](https://github.com/primefaces/primevue/issues/424)

## [2.0.6](https://github.com/primefaces/primevue/tree/2.0.6) (2020-08-04)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.5...2.0.6)

**Implemented New Features and Enhancements:**

- Improve connected overlay positioning [\#418](https://github.com/primefaces/primevue/issues/418)
- TabMenu should include subpaths in active tab detection [\#417](https://github.com/primefaces/primevue/issues/417)
- Rename toast message title class [\#420](https://github.com/primefaces/primevue/issues/420)

**Fixed bugs:**

- TabMenu error when no route matches one of the menu paths [\#416](https://github.com/primefaces/primevue/issues/416)
- DataTable row reorder demo not working [\#419](https://github.com/primefaces/primevue/issues/419)
- DataTable: Exporting an empty DataTable throws TypeError [\#413](https://github.com/primefaces/primevue/issues/413)
- Duplicate keys in TreeTable [\#424](https://github.com/primefaces/primevue/issues/424)
- Fixed typo in ProgressBarDoc.vue [\#414](https://github.com/primefaces/primevue/issues/414)
- Paginator is displayed over table loading overlay [\#422](https://github.com/primefaces/primevue/issues/422)
- p-error, p-invalid styling missing on some form elements [\#421](https://github.com/primefaces/primevue/issues/421)

## [2.0.5](https://github.com/primefaces/primevue/tree/2.0.5) (2020-07-24)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.4...2.0.5)

**Implemented New Features and Enhancements:**

- SideBar p-sidebar-mask div is not removed automatically [\#329](https://github.com/primefaces/primevue/issues/329)
- Block UI mask remove automatically [\#409](https://github.com/primefaces/primevue/issues/409)

**Fixed bugs:**

- Calendar mask animation [\#408](https://github.com/primefaces/primevue/issues/408)

## [2.0.4](https://github.com/primefaces/primevue/tree/2.0.4) (2020-07-23)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.3...2.0.4)

**Implemented New Features and Enhancements:**

- MultiSelect close icon spacing issue [\#405](https://github.com/primefaces/primevue/issues/405)
- Refactor OrderList and PickList header style classes [\#403](https://github.com/primefaces/primevue/issues/403)
- Improve Dialog padding [\#404](https://github.com/primefaces/primevue/issues/404)
- Refactor selectbutton focus visuals [\#406](https://github.com/primefaces/primevue/issues/406)

**Fixed bugs:**

- Alignment issue on left and right contents of Toolbar [\#400](https://github.com/primefaces/primevue/issues/400)
- Remove default text-decoration style from the header links on Fieldset [\#399](https://github.com/primefaces/primevue/issues/399)

## [2.0.3](https://github.com/primefaces/primevue/tree/2.0.3) (2020-07-18)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.2...2.0.3)

**Breaking changes:**

- Improve Toast CSS structure and Add new positions [\#391](https://github.com/primefaces/primevue/issues/391)

**Implemented New Features and Enhancements:**

- Add p-button-plain add-on for text button [\#398](https://github.com/primefaces/primevue/issues/398)
- Sort the icons alphabetically in the documentation [\#385](https://github.com/primefaces/primevue/issues/385)
- Button slot [\#388](https://github.com/primefaces/primevue/pull/388)
- Rename p-datatable-row to p-selectable-row [\#397](https://github.com/primefaces/primevue/issues/397)
- Cleanup FullCalendar CSS [\#392](https://github.com/primefaces/primevue/issues/392)

**Fixed bugs:**

- Alignment issue on tree [\#395](https://github.com/primefaces/primevue/issues/395)
- Add type="button" to buttons to avoid form submission [\#394](https://github.com/primefaces/primevue/issues/394)
- Wrong class name at FileUpload [\#390](https://github.com/primefaces/primevue/issues/390)

## [2.0.2](https://github.com/primefaces/primevue/tree/2.0.2) (2020-07-12)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.1...2.0.2)

**Implemented New Features and Enhancements:**

- OverlayPanel padding visual problem [\#382](https://github.com/primefaces/primevue/issues/382)
- Improved active state for dark themes [\#383](https://github.com/primefaces/primevue/issues/383)

## [2.0.1](https://github.com/primefaces/primevue/tree/2.0.1) (2020-07-10)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.0...2.0.1)

**Implemented New Features and Enhancements:**

- Ability to programmatically show or hide Dropdown/MultiSelect [\#368](https://github.com/primefaces/primevue/issues/368)
- Ability to add scaling inputs by group [\#373](https://github.com/primefaces/primevue/issues/373)
- Support for left and right icons for Input [\#379](https://github.com/primefaces/primevue/issues/379)

**Fixed bugs:**

- Datatable with RowGroup and Scroll scrollbar misplaced [\#380](https://github.com/primefaces/primevue/issues/380)
- InlineMessage typescript declaration is not available at package root [\#366](https://github.com/primefaces/primevue/issues/366)
- Editor readonly not working due to typo  [\#369](https://github.com/primefaces/primevue/issues/369)
- Message error with Ripple [\#378](https://github.com/primefaces/primevue/issues/378)
- Separator problem with Menu [\#377](https://github.com/primefaces/primevue/issues/377)

## [2.0.0](https://github.com/primefaces/primevue/tree/2.0.0) (2020-07-06)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.0-rc.3...2.0.0)

## [2.0.0-rc.3](https://github.com/primefaces/primevue/tree/2.0.0-rc.3) (2020-07-04)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.0-rc.2...2.0.0-rc.3)

**Implemented New Features and Enhancements:**

- FileLimit for FileUpload [\#361](https://github.com/primefaces/primevue/issues/361)
- Custom Upload for FileUpload [\#360](https://github.com/primefaces/primevue/issues/360)
- Filter event for Listbox, Dropdown and MultiSelect [\#359](https://github.com/primefaces/primevue/issues/359)
- DataView should reset paginator on sort [\#356](https://github.com/primefaces/primevue/issues/356)

**Fixed bugs:**

- Usage of header slot produces JavaScript error when beeing combined with ColumnGroups [\#349](https://github.com/primefaces/primevue/issues/349)
- Messages are not visible in simple uploader [\#343](https://github.com/primefaces/primevue/issues/343)
- Accordion breaks input components inside [\#342](https://github.com/primefaces/primevue/issues/342)
- Picklist 'move-all-to-source' event  argument e.items is empty [\#341](https://github.com/primefaces/primevue/issues/341)
- datatable filter not work in some firefox [\#325](https://github.com/primefaces/primevue/issues/325)
- DataTable : \(row\) editing + selection column - focus issues [\#315](https://github.com/primefaces/primevue/issues/315)
- Datatable scrollable mode doesn't load Loading Template [\#296](https://github.com/primefaces/primevue/issues/296)

## [2.0.0-rc.2](https://github.com/primefaces/primevue/tree/2.0.0-rc.2) (2020-07-02)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.0-rc.1...2.0.0-rc.2)

**Implemented New Features and Enhancements:**

- Material Theme [\#363](https://github.com/primefaces/primevue/issues/363)
- Bootstrap Theme [\#362](https://github.com/primefaces/primevue/issues/362)
- Improve Galleria animation on FullScreen mode [\#346](https://github.com/primefaces/primevue/issues/346)

**Fixed bugs:**

- Item content in Carousel does not expand according to the wrapper element  [\#348](https://github.com/primefaces/primevue/issues/348)
- InputNumber prevents min key number [\#337](https://github.com/primefaces/primevue/issues/337)

## [2.0.0-rc.1](https://github.com/primefaces/primevue/tree/2.0.0-rc.1) (2020-05-28)

[Full Changelog](https://github.com/primefaces/primevue/compare/2.0.0-beta.1...2.0.0-rc.1)

**Implemented New Features and Enhancements:**

- Disable virtual keyboard in calendar [\#334](https://github.com/primefaces/primevue/issues/334)
- Rename dialog titlebar class to dialog header [\#333](https://github.com/primefaces/primevue/issues/333)
- Flex Scroll height for DataTable [\#328](https://github.com/primefaces/primevue/issues/328)
- New Component: ScrollPanel [\#322](https://github.com/primefaces/primevue/issues/322)
- Refactor p-panel-titlebar to p-panel-header [\#321](https://github.com/primefaces/primevue/issues/321)
- Terminal should scroll to bottom after command [\#319](https://github.com/primefaces/primevue/issues/319)
- Rename Nova Themes [\#318](https://github.com/primefaces/primevue/issues/318)
- Datatable coltoggle changes columns order. [\#311](https://github.com/primefaces/primevue/issues/311)

**Fixed bugs:**

- Table loader is not visible in scrollable table [\#332](https://github.com/primefaces/primevue/issues/332)
- Alignment issue on Galleria with left and right thumbnail position [\#327](https://github.com/primefaces/primevue/issues/327)
- InputNumber Up Down buttons send form on submit [\#313](https://github.com/primefaces/primevue/issues/313)
- Slider handle moves on click [\#298](https://github.com/primefaces/primevue/issues/298)

## [2.0.0-beta.1](https://github.com/primefaces/primevue/tree/2.0.0-beta.1) (2020-05-15)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.3.2...2.0.0-beta.1)

**Implemented New Features and Enhancements:**

- Modernize CSS [\#263](https://github.com/primefaces/primevue/issues/263)
- Responsive Menubar [\#316](https://github.com/primefaces/primevue/issues/316)
- Top and Bottom icon positioning for button [\#309](https://github.com/primefaces/primevue/issues/309)
- Badges and Tags [\#308](https://github.com/primefaces/primevue/issues/308)
- Saga and Vela Themes [\#307](https://github.com/primefaces/primevue/issues/307)
- Add link button [\#306](https://github.com/primefaces/primevue/issues/306)
- Icons inside InputText [\#305](https://github.com/primefaces/primevue/issues/305)
- Add inputId to Dropdown and MultiSelect [\#303](https://github.com/primefaces/primevue/issues/303)
- ToggleButton refactor [\#297](https://github.com/primefaces/primevue/issues/297)
- Decouple MegaMenu from PrimeFlex [\#295](https://github.com/primefaces/primevue/issues/295)

**Breaking Changes:**
- Remove Spinner [\#287](https://github.com/primefaces/primevue/issues/287)
- Rename ValidationMessage to InlineMessage [\#301](https://github.com/primefaces/primevue/issues/301)
- Refactor Messages css naming [\#302](https://github.com/primefaces/primevue/issues/302)

## [1.3.2](https://github.com/primefaces/primevue/tree/1.3.2) (2020-04-24)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.3.1...1.3.2)

**Fixed bugs:**

- Context Menu throw error after update to 1.3.1 [\#291](https://github.com/primefaces/primevue/issues/291)
- InputMask somehow clears the initial value to empty string [\#290](https://github.com/primefaces/primevue/issues/290)

## [1.3.1](https://github.com/primefaces/primevue/tree/1.3.1) (2020-04-23)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.3.0...1.3.1)

**Implemented New Features and Enhancements:**

- FilterPlaceholder for Listbox [\#284](https://github.com/primefaces/primevue/issues/284)
- Function support for MenuModel visible prop [\#286](https://github.com/primefaces/primevue/issues/286)

**Fixed bugs:**

- Group Header Broken without Footer Template [\#288](https://github.com/primefaces/primevue/issues/288)
- SplitButton is misaligned [\#289](https://github.com/primefaces/primevue/issues/289)

## [1.3.0](https://github.com/primefaces/primevue/tree/1.3.0) (2020-04-20)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.1.0...1.3.0)

**Implemented New Features and Enhancements:**

- Add empty template to FileUpload [\#265](https://github.com/primefaces/primevue/issues/265)
- DragDrop support for FileUpload [\#262](https://github.com/primefaces/primevue/issues/262)
- Improve DataTable ContextMenu Styling [\#253](https://github.com/primefaces/primevue/issues/253)
- Separator, addOnBlur and allowDuplicate for Chips [\#252](https://github.com/primefaces/primevue/issues/252)
- Add id property to Steps [\#251](https://github.com/primefaces/primevue/issues/251)
- ReImplemented Steps styles [\#250](https://github.com/primefaces/primevue/issues/250)
- Improve autocomplete css by using flex [\#249](https://github.com/primefaces/primevue/issues/249)
- Add menubar-left and menubar-right slots to Menubar [\#246](https://github.com/primefaces/primevue/issues/246)
- New Component: Galleria [\#212](https://github.com/primefaces/primevue/issues/212)
- Ability to disable PanelMenu items [\#171](https://github.com/primefaces/primevue/issues/171)
- TreeTable should pass more information on page-sort-filter events [\#282](https://github.com/primefaces/primevue/issues/282)
- filterLocale for components with filtering [\#279](https://github.com/primefaces/primevue/issues/279)
- Update sort icons [\#278](https://github.com/primefaces/primevue/issues/278)
- Placeholder for Chips [\#277](https://github.com/primefaces/primevue/issues/277)
- New Component: InputNumber [\#275](https://github.com/primefaces/primevue/issues/275)
- Value slot for Dropdown [\#271](https://github.com/primefaces/primevue/issues/271)
- Removable sort on DataTable - TreeTable [\#235](https://github.com/primefaces/primevue/issues/235)
- Order indicators for Multi column sorting [\#189](https://github.com/primefaces/primevue/issues/189)

**Fixed bugs:**

- Calendar.vue: Poor handling of user input [\#70](https://github.com/primefaces/primevue/issues/70)
- Carousel - Button inside carousel-item is not clickable in mobile phones [\#264](https://github.com/primefaces/primevue/issues/264)
- Popup menu does not appear where it should  [\#258](https://github.com/primefaces/primevue/issues/258)
- FileUpload Multiple: Error when deleting file before upload [\#257](https://github.com/primefaces/primevue/issues/257)
- FileUpload in auto mode sends two post requests in IE11 [\#254](https://github.com/primefaces/primevue/issues/254)
- TreeTable global filtering fails [\#283](https://github.com/primefaces/primevue/issues/283)
- Loop on treetable sort [\#281](https://github.com/primefaces/primevue/issues/281)
- Datatable Group footer doesn't work [\#276](https://github.com/primefaces/primevue/issues/276)
- Textarea with autoResize true not displayed correctly when initially hidden [\#274](https://github.com/primefaces/primevue/issues/274)
- Calendar is not empty when the v-model is null [\#270](https://github.com/primefaces/primevue/issues/270)


## [1.2.0](https://github.com/primefaces/primevue/tree/1.2.0) (2020-04-17)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.6...1.1.0)

**Implemented New Features and Enhancements:**

- Improve autocomplete css by using flex [\#249](https://github.com/primefaces/primevue/issues/249)
- Improve DataTable ContextMenu Styling [\#253](https://github.com/primefaces/primevue/issues/253)
- DragDrop support for FileUpload [\#262](https://github.com/primefaces/primevue/issues/262)
- Add empty template to FileUpload [\#265](https://github.com/primefaces/primevue/issues/265)
- Separator, addOnBlur and allowDuplicate for Chips [\#252](https://github.com/primefaces/primevue/issues/252)
- Add menubar-left and menubar-right slots to Menubar [\#246](https://github.com/primefaces/primevue/issues/246)
- Ability to disable PanelMenu items [\#171](https://github.com/primefaces/primevue/issues/171)
- Add id property to Steps [\#251](https://github.com/primefaces/primevue/issues/251)
- ReImplemented Steps styles [\#250](https://github.com/primefaces/primevue/issues/250)
- ReImplemented Steps styles [\#250](https://github.com/primefaces/primevue/issues/250)

**Fixed bugs:**

- Carousel - Button inside carousel-item is not clickable in mobile phones [\#264](https://github.com/primefaces/primevue/issues/264)
- FileUpload Multiple: Error when deleting file before upload [\#257](https://github.com/primefaces/primevue/issues/257)
- Popup menu does not appear where it should [\#258](https://github.com/primefaces/primevue/issues/258)
- FileUpload in auto mode sends two post requests in IE11 [\#254](https://github.com/primefaces/primevue/issues/254)

**Deprecated:**

- Deprecate menubar custom slot [\#260](https://github.com/primefaces/primevue/issues/260)

## [1.1.0](https://github.com/primefaces/primevue/tree/1.1.0) (2020-03-17)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.6...1.1.0)

**Implemented New Features and Enhancements:**

- Move column filters to their own row [\#226](https://github.com/primefaces/primevue/issues/226)
- Loading template for DataTable [\#244](https://github.com/primefaces/primevue/issues/244)
- Move TreeTable filters to their own header row [\#241](https://github.com/primefaces/primevue/issues/241)
- Add filterHeaderStyle and filterHeaderClass to Column [\#240](https://github.com/primefaces/primevue/issues/240)
- Unify placeholder colors [\#239](https://github.com/primefaces/primevue/issues/239)
- Opacity Animation for Modals [\#237](https://github.com/primefaces/primevue/issues/237)
- Remove Responsive DataTable [\#232](https://github.com/primefaces/primevue/issues/232)
- Display issues with Chips [\#231](https://github.com/primefaces/primevue/issues/231)
- More options for currentPageReportTemplate [\#230](https://github.com/primefaces/primevue/issues/230)
- New Component: Terminal [\#229](https://github.com/primefaces/primevue/issues/229)
- New Component: BlockUI [\#211](https://github.com/primefaces/primevue/issues/211)
- Ability to disable TabMenu items [\#172](https://github.com/primefaces/primevue/issues/172)
- Ability to disable MegaMenu items [\#170](https://github.com/primefaces/primevue/issues/170)

**Fixed bugs:**

- Disabled menuitems with routerLink integration are still functional [\#243](https://github.com/primefaces/primevue/issues/243)
- Disabled menuitems opacity is doubled in MenuBar, TieredMenu and ContextMenu [\#242](https://github.com/primefaces/primevue/issues/242)
- MultiSelect label size grows on items select [\#238](https://github.com/primefaces/primevue/issues/238)
- DataTable scrollHeight doesn't calculate correctly with frozen columns and percentages [\#234](https://github.com/primefaces/primevue/issues/234)
- Select components may throw non-primitive key error [\#233](https://github.com/primefaces/primevue/issues/233)

## [1.0.6](https://github.com/primefaces/primevue/tree/1.0.6) (2020-03-04)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.5...1.0.6)

**Implemented New Features and Enhancements:**

- Add appendTo to components with Overlays [\#224](https://github.com/primefaces/primevue/issues/224)
- Add filterField to column [\#223](https://github.com/primefaces/primevue/issues/223)
- Accents support in Table filtering [\#220](https://github.com/primefaces/primevue/issues/220)
- Date support in table filtering [\#219](https://github.com/primefaces/primevue/issues/219)
- New filtering modes for Table [\#217](https://github.com/primefaces/primevue/issues/217)

**Fixed bugs:**

- CurrentPageReport is initially wrong [\#222](https://github.com/primefaces/primevue/issues/222)
- Primitive values support in Select components [\#221](https://github.com/primefaces/primevue/issues/221)
- sortField of column is ignored [\#216](https://github.com/primefaces/primevue/issues/216)
- DataTable Column Group Sort Bug [\#214](https://github.com/primefaces/primevue/issues/214)

## [1.0.5](https://github.com/primefaces/primevue/tree/1.0.5) (2020-02-27)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.4...1.0.5)

**Implemented New Features and Enhancements:**

- Tooltip Component missing typescript declaration file [\#202](https://github.com/primefaces/primevue/issues/202)

**Fixed bugs:**

- Tooltip reactive text [\#206](https://github.com/primefaces/primevue/issues/206)
- Editor infinite loop with some specific values [\#204](https://github.com/primefaces/primevue/issues/204)
- DataTable \> Missing `custom` filterMatchMode [\#200](https://github.com/primefaces/primevue/issues/200)
- Top\* and Bottom\* animation are not working correctly on Dialog with 'position' property [\#190](https://github.com/primefaces/primevue/issues/190)

## [1.0.4](https://github.com/primefaces/primevue/tree/1.0.4) (2020-02-08)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.3...1.0.4)

**Fixed bugs:**

- Dialog positions regressions [\#191](https://github.com/primefaces/primevue/issues/191)

## [1.0.3](https://github.com/primefaces/primevue/tree/1.0.3) (2020-02-07)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.2...1.0.3)

**Implemented New Features and Enhancements:**

- Add position property to Dialog [\#184](https://github.com/primefaces/primevue/issues/184)
- Add maximizable property to Dialog [\#183](https://github.com/primefaces/primevue/issues/183)
- DataTable "$event" argument on page/sort events does not contains filterSearchMode. [\#181](https://github.com/primefaces/primevue/issues/181)
- Dialog header not visible [\#179](https://github.com/primefaces/primevue/issues/179)
- Ability to disable TieredMenu items [\#173](https://github.com/primefaces/primevue/issues/173)
- Ability to disable ContextMenu items [\#169](https://github.com/primefaces/primevue/issues/169)
- Ability to disable Menubar items [\#168](https://github.com/primefaces/primevue/issues/168)

**Fixed bugs:**

- Chart.vue : Error in v-on handler: "TypeError: this.emit is not a function" [\#188](https://github.com/primefaces/primevue/issues/188)
- OverlayPanel dismissable does not work [\#187](https://github.com/primefaces/primevue/issues/187)
- Could not find module './components/row/Row' [\#185](https://github.com/primefaces/primevue/issues/185)
- Style classes are not rendered correctly on Dialog [\#182](https://github.com/primefaces/primevue/issues/182)

## [1.0.2](https://github.com/primefaces/primevue/tree/1.0.2) (2020-01-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0...1.0.2)

**Implemented New Features and Enhancements:**

- Align focus visuals with the theme [\#177](https://github.com/primefaces/primevue/issues/177)
- Refactor SplitButton to use Menu [\#174](https://github.com/primefaces/primevue/issues/174)
- DataTable onPage event fires without sort and filter information [\#163](https://github.com/primefaces/primevue/issues/163)
- Ability to disable SplitButton or Menu items [\#161](https://github.com/primefaces/primevue/issues/161)
- Enter key should select a PickList item [\#156](https://github.com/primefaces/primevue/issues/156)
- Dialog in mobile view [\#153](https://github.com/primefaces/primevue/issues/153)
- Dropdown and MultiSelect on expand event [\#150](https://github.com/primefaces/primevue/issues/150)

**Fixed bugs:**

- Editable Dropdown loses focus [\#149](https://github.com/primefaces/primevue/issues/149)
- Rename select event with \*-select [\#148](https://github.com/primefaces/primevue/issues/148)
- Dialog block UI removes page scroll [\#145](https://github.com/primefaces/primevue/issues/145)
- Calendar select event has no value [\#144](https://github.com/primefaces/primevue/issues/144)
- Calendar manual input fails [\#143](https://github.com/primefaces/primevue/issues/143)
- Calendar giving focus to today when disabled [\#141](https://github.com/primefaces/primevue/issues/141)
- optionValue and dataKey combination is broken is Select Components [\#90](https://github.com/primefaces/primevue/issues/90)
- DataTable column headers always receive focus [\#176](https://github.com/primefaces/primevue/issues/176)
- Disabled button should remove pointer cursor [\#175](https://github.com/primefaces/primevue/issues/175)
- Dialog visuals broken when initially displayed [\#167](https://github.com/primefaces/primevue/issues/167)
- Dialog animation leave does not work [\#166](https://github.com/primefaces/primevue/issues/166)
- rowsPerPageOptions dropdown is not coming in Paginator [\#159](https://github.com/primefaces/primevue/issues/159)
- Calendar today button TypeError: Cannot read property 'currentTarget' of null [\#158](https://github.com/primefaces/primevue/issues/158)
- Row edit save not working properly in data table [\#151](https://github.com/primefaces/primevue/issues/151)

## [1.0.0](https://github.com/primefaces/primevue/tree/1.0.0) (2020-01-13)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.6...1.0.0)

**Implemented New Features and Enhancements:**

- New Component: ColorPicker [\#139](https://github.com/primefaces/primevue/issues/139)
- Enhance Dialog Positioning [\#136](https://github.com/primefaces/primevue/issues/136)

**Fixed bugs:**

- Error: Do not access Object.prototype method [\#138](https://github.com/primefaces/primevue/issues/138)
- The slot \#empty of DataTable not working [\#137](https://github.com/primefaces/primevue/issues/137)
- Sidebar showCloseIcon not working [\#135](https://github.com/primefaces/primevue/issues/135)
- Error with calendar year navigator [\#134](https://github.com/primefaces/primevue/issues/134)

## [1.0.0-rc.6](https://github.com/primefaces/primevue/tree/1.0.0-rc.6) (2019-12-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.5...1.0.0-rc.6)

**Fixed bugs:**

- Keydown causes sort on sortable header [\#130](https://github.com/primefaces/primevue/issues/130)

## [1.0.0-rc.5](https://github.com/primefaces/primevue/tree/1.0.0-rc.5) (2019-12-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.4...1.0.0-rc.5)

**Implemented New Features and Enhancements:**

- TimePicker buttons should trap focus [\#128](https://github.com/primefaces/primevue/issues/128)

**Fixed bugs:**

- RadioButton throws error [\#129](https://github.com/primefaces/primevue/issues/129)

## [1.0.0-rc.4](https://github.com/primefaces/primevue/tree/1.0.0-rc.4) (2019-12-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.3...1.0.0-rc.4)

**Implemented New Features and Enhancements:**

- Inplace focus visuals not themed [\#123](https://github.com/primefaces/primevue/issues/123)
- New Component: Tooltip [\#122](https://github.com/primefaces/primevue/issues/122)
- Keyboard accessibility for Calendar [\#109](https://github.com/primefaces/primevue/issues/109)
- Enhance ARIA roles and attributes for the components [\#108](https://github.com/primefaces/primevue/issues/108)

**Fixed bugs:**

- Error in datatable keyboard navigation [\#127](https://github.com/primefaces/primevue/issues/127)
- Scroll+Paginator fails [\#126](https://github.com/primefaces/primevue/issues/126)

## [1.0.0-rc.3](https://github.com/primefaces/primevue/tree/1.0.0-rc.3) (2019-12-23)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.2...1.0.0-rc.3)

**Fixed bugs:**

- DataView Grid should have nogutter [\#121](https://github.com/primefaces/primevue/issues/121)
- Menu should prevent default action when there is none [\#120](https://github.com/primefaces/primevue/issues/120)
- Range slider goes out of bounds [\#119](https://github.com/primefaces/primevue/issues/119)

## [1.0.0-rc.2](https://github.com/primefaces/primevue/tree/1.0.0-rc.2) (2019-12-20)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-rc.1...1.0.0-rc.2)

**Implemented New Features and Enhancements:**

- Add p-placeholder class to Multiselect label [\#111](https://github.com/primefaces/primevue/issues/111)

**Fixed bugs:**

- ContextMenu fails in global mode [\#118](https://github.com/primefaces/primevue/issues/118)
- ProgressBar showValue prop is ignored [\#117](https://github.com/primefaces/primevue/issues/117)
- Calendar icon button submitting form [\#114](https://github.com/primefaces/primevue/issues/114)
- Message icon correction [\#112](https://github.com/primefaces/primevue/issues/112)
- Disabled Dropdown still picking values [\#110](https://github.com/primefaces/primevue/issues/110)
- Calendar clear button does not reset the input field [\#107](https://github.com/primefaces/primevue/issues/107)

## [1.0.0-rc.1](https://github.com/primefaces/primevue/tree/1.0.0-rc.1) (2019-12-10)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.14...1.0.0-rc.1)

**Implemented New Features and Enhancements:**

- New Component: Steps [\#103](https://github.com/primefaces/primevue/issues/103)
- New Component: PanelMenu [\#102](https://github.com/primefaces/primevue/issues/102)
- New Component: ContextMenu [\#101](https://github.com/primefaces/primevue/issues/101)
- New Component: MegaMenu [\#100](https://github.com/primefaces/primevue/issues/100)
- New Component: TabMenu [\#99](https://github.com/primefaces/primevue/issues/99)
- New Component: Menubar [\#98](https://github.com/primefaces/primevue/issues/98)
- New Component: TieredMenu [\#97](https://github.com/primefaces/primevue/issues/97)
- New Component: Breadcrumb [\#96](https://github.com/primefaces/primevue/issues/96)
- Add default focus on searchable dropdowns [\#95](https://github.com/primefaces/primevue/issues/95)
- Nuxt integration [\#86](https://github.com/primefaces/primevue/issues/86)

**Fixed bugs:**

- Paginator should go to last page if current page has no data [\#106](https://github.com/primefaces/primevue/issues/106)
- TreeNode is not toggled with left and right arrow keys [\#105](https://github.com/primefaces/primevue/issues/105)
- Dialog is not modal when v-if used [\#94](https://github.com/primefaces/primevue/issues/94)
- DataTable rowClick returns a dom event with no data property [\#91](https://github.com/primefaces/primevue/issues/91)

## [1.0.0-beta.14](https://github.com/primefaces/primevue/tree/1.0.0-beta.14) (2019-11-20)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.13...1.0.0-beta.14)

**Implemented New Features and Enhancements:**

- Scrollable DataTable [\#87](https://github.com/primefaces/primevue/issues/87)
- Add p-placeholder to Dropdown label [\#84](https://github.com/primefaces/primevue/issues/84)
- Add row-click event to Table [\#82](https://github.com/primefaces/primevue/issues/82)

## [1.0.0-beta.13](https://github.com/primefaces/primevue/tree/1.0.0-beta.13) (2019-11-01)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.12...1.0.0-beta.13)

**Implemented New Features and Enhancements:**

- Ability to style certain rows and cells in Table [\#81](https://github.com/primefaces/primevue/issues/81)
- Menu Component a11y issue [\#78](https://github.com/primefaces/primevue/issues/78)
- Modal dialog not blocking background [\#77](https://github.com/primefaces/primevue/issues/77)

**Fixed bugs:**

- Modal dialog is not destroyed properly [\#80](https://github.com/primefaces/primevue/issues/80)

## [1.0.0-beta.12](https://github.com/primefaces/primevue/tree/1.0.0-beta.12) (2019-10-22)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.11...1.0.0-beta.12)

**Implemented New Features and Enhancements:**

- New Carousel Component [\#73](https://github.com/primefaces/primevue/issues/73)
- Expandable Rows for DataTable [\#72](https://github.com/primefaces/primevue/issues/72)
- TableState for DataTable [\#68](https://github.com/primefaces/primevue/issues/68)
- Row Grouping for DataTable [\#65](https://github.com/primefaces/primevue/issues/65)

**Fixed bugs:**

- Time buttons select a date on mouseout event on Calendar with showTime property [\#75](https://github.com/primefaces/primevue/issues/75)
- Clicking column header resets paginator [\#74](https://github.com/primefaces/primevue/issues/74)
- Calendar.vue: "close on blur" not working properly [\#71](https://github.com/primefaces/primevue/issues/71)

## [1.0.0-beta.11](https://github.com/primefaces/primevue/tree/1.0.0-beta.11) (2019-10-18)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.10...1.0.0-beta.11)

**Implemented New Features and Enhancements:**

- Row Reordering with DragDrop [\#69](https://github.com/primefaces/primevue/issues/69)
- Improve component styles on Luna and Nova Themes  [\#66](https://github.com/primefaces/primevue/issues/66)
- Column Reordering with DragDrop [\#64](https://github.com/primefaces/primevue/issues/64)
- ColumnGroups for DataTable [\#63](https://github.com/primefaces/primevue/issues/63)

**Fixed bugs:**

- Accordion and TabView do not sync children changes [\#67](https://github.com/primefaces/primevue/issues/67)
- Accordion and TabView create empty tabs [\#59](https://github.com/primefaces/primevue/issues/59)

## [1.0.0-beta.10](https://github.com/primefaces/primevue/tree/1.0.0-beta.10) (2019-10-15)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.9...1.0.0-beta.10)

**Implemented New Features and Enhancements:**

- New Component: Carousel [\#61](https://github.com/primefaces/primevue/issues/61)

**Fixed bugs:**

- Menu and OverlayPanel target position miscalculated [\#62](https://github.com/primefaces/primevue/issues/62)
- Dataview paginator gets out of sync [\#60](https://github.com/primefaces/primevue/issues/60)

## [1.0.0-beta.9](https://github.com/primefaces/primevue/tree/1.0.0-beta.9) (2019-10-01)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.8...1.0.0-beta.9)

**Implemented New Features and Enhancements:**

- Remove empty spaces with Lint [\#58](https://github.com/primefaces/primevue/issues/58)
- Reimplement Accordion with Templating [\#56](https://github.com/primefaces/primevue/issues/56)
- Reimplement TabView with Templating [\#51](https://github.com/primefaces/primevue/issues/51)

**Fixed bugs:**

- MultiSelect filter cannot be turned off [\#57](https://github.com/primefaces/primevue/issues/57)
- DataTable sortField cannot be synced [\#55](https://github.com/primefaces/primevue/issues/55)
- Duplicate key issue in menu component [\#52](https://github.com/primefaces/primevue/issues/52)
- Calendar.vue: when the value is updated, the component partially updates itself [\#47](https://github.com/primefaces/primevue/issues/47)
- MultiSelect.vue: error on onToggleAll and bad default placeholder [\#45](https://github.com/primefaces/primevue/issues/45)
- Calendar clear button does not reset the input field [\#42](https://github.com/primefaces/primevue/issues/42)
- Time does not stop spinning in Calendar [\#40](https://github.com/primefaces/primevue/issues/40)

## [1.0.0-beta.8](https://github.com/primefaces/primevue/tree/1.0.0-beta.8) (2019-08-21)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.7...1.0.0-beta.8)

**Fixed bugs:**

- Cannot delete date from calendar once it's selected [\#38](https://github.com/primefaces/primevue/issues/38)
- Dropdown click icon gives error on Firefox [\#37](https://github.com/primefaces/primevue/issues/37)
- TreeTable single sort broken [\#35](https://github.com/primefaces/primevue/issues/35)
- TreeTable highlights unsorted columns [\#34](https://github.com/primefaces/primevue/issues/34)
- InputMask pressing enter [\#33](https://github.com/primefaces/primevue/issues/33)
- Column component registration fails with Typescript [\#29](https://github.com/primefaces/primevue/issues/29)

## [1.0.0-beta.7](https://github.com/primefaces/primevue/tree/1.0.0-beta.7) (2019-08-15)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.6...1.0.0-beta.7)

**Implemented New Features and Enhancements:**

- New Component: TreeTable [\#31](https://github.com/primefaces/primevue/issues/31)
- Resizable Columns for DataTable [\#30](https://github.com/primefaces/primevue/issues/30)
- New Component: InputMask [\#26](https://github.com/primefaces/primevue/issues/26)

## [1.0.0-beta.6](https://github.com/primefaces/primevue/tree/1.0.0-beta.6) (2019-08-05)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.5...1.0.0-beta.6)

**Implemented New Features and Enhancements:**

- New Component: Tree [\#28](https://github.com/primefaces/primevue/issues/28)

## [1.0.0-beta.5](https://github.com/primefaces/primevue/tree/1.0.0-beta.5) (2019-07-29)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.3...1.0.0-beta.5)

**Implemented New Features and Enhancements:**

- New Component: DataTable [\#23](https://github.com/primefaces/primevue/issues/23)
- Convert emptyMessage to a template for DataView [\#10](https://github.com/primefaces/primevue/issues/10)
- Auto z-index layering for Toast [\#9](https://github.com/primefaces/primevue/issues/9)
- Reset DataTable page after sort [\#27](https://github.com/primefaces/primevue/issues/27)
- New Component: ProgressSpinner [\#24](https://github.com/primefaces/primevue/issues/24)
- New Component: DeferredContent [\#20](https://github.com/primefaces/primevue/issues/20)
- New Component: Inplace [\#19](https://github.com/primefaces/primevue/issues/19)
- New Component: PickList [\#18](https://github.com/primefaces/primevue/issues/18)
- New Component: OrderList [\#17](https://github.com/primefaces/primevue/issues/17)
- New Component: OrganizationChart [\#16](https://github.com/primefaces/primevue/issues/16)

**Fixed bugs:**

- Calendar today button throws an error [\#22](https://github.com/primefaces/primevue/issues/22)
- DataView paginator is always displayed [\#21](https://github.com/primefaces/primevue/issues/21)
- Dropdown ignores false or 0 values [\#11](https://github.com/primefaces/primevue/issues/11)

## [1.0.0-beta.3](https://github.com/primefaces/primevue/tree/1.0.0-beta.3) (2019-05-30)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.2...1.0.0-beta.3)

## [1.0.0-beta.2](https://github.com/primefaces/primevue/tree/1.0.0-beta.2) (2019-05-28)

[Full Changelog](https://github.com/primefaces/primevue/compare/1.0.0-beta.1...1.0.0-beta.2)

## [1.0.0-beta.1](https://github.com/primefaces/primevue/tree/1.0.0-beta.1) (2019-05-27)

[Full Changelog](https://github.com/primefaces/primevue/compare/9d2c525d528c9bd6f306c6f550e3f0eef7879054...1.0.0-beta.1)



\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*
